function PAB:profileshub_testfunc()
if Profiles_global_que[1] == "Keyboard binds" and Profiles_global_que[2] == "Macros" and Profiles_global_que[3] == "Action bars" then
	PAB.profiles_hub_tests.tests = {		
		["1. ProfilesHub Whitebox"] =
		{
			setup = function()
					PROFILES_TYST = 1
			end,
			
			teardown = function()
				PROFILES_TYST = nil
				
				PAB:DeleteProfil("TestSuiteTestProfile")
				KPS:DeleteProfil("TestSuiteTestProfile")
				MPS:DeleteProfil("TestSuiteTestProfile")
			end,
			
			
			
			["1. Profiles_global_que hash"] = function()
				wowUnit:assertEquals(Profiles_global_que[3],"Action bars","PAB")
				wowUnit:assertEquals(Profiles_global_que[2],"Macros","MPS")
				wowUnit:assertEquals(Profiles_global_que[1],"Keyboard binds","KPS")
			end,
			
			["2. PAB: Run standalone"] = function()
				-- Backup the global var
				local Profiles_global_que_local = {}
				Profiles_global_que_local = copyTable(Profiles_global_que)

				
				-- Kill MPS and KPS
				Profiles_global_que[1] = nil
				Profiles_global_que[2] = nil
				
				wowUnit:assertEquals(Profiles_global_que[3],"Action bars","PAB")
				wowUnit:assertEquals(Profiles_global_que[2],nil,"MPS removed")
				wowUnit:assertEquals(Profiles_global_que[1],nil,"KPS removed")
				
				PAB:PreSaveABProfile("TestSuiteTestProfile")
				
				wowUnit:assert(PAB:ExistsProfile('TestSuiteTestProfile'),"PAB:Profile saved.")

				-- Restore the global var
				Profiles_global_que = copyTable(Profiles_global_que_local)
				
				-- Make sure global var looks like before!
				wowUnit:assertEquals(Profiles_global_que[3],"Action bars","PAB")
				wowUnit:assertEquals(Profiles_global_que[2],"Macros","MPS")
				wowUnit:assertEquals(Profiles_global_que[1],"Keyboard binds","KPS")
			end,
			
			["3. MPS: Run standalone"] = function()
			
				wowUnit:assert(MPS,"MPS loaded")
				if not MPS then return end
				
				-- Backup the global var
				local Profiles_global_que_local = {}
				Profiles_global_que_local = copyTable(Profiles_global_que)
					
		
				-- Kill PAB and KPS
				Profiles_global_que[1] = nil
				Profiles_global_que[3] = nil
				
				
				wowUnit:assertEquals(Profiles_global_que[3],nil,"PAB removed")
				wowUnit:assertEquals(Profiles_global_que[2],"Macros","MPS slave")
				wowUnit:assertEquals(Profiles_global_que[1],nil,"KPS removed")
				
				MPS:PreSaveMacroProfile("TestSuiteTestProfile")
				
				wowUnit:assert(MPS:ExistsProfile('TestSuiteTestProfile'),"MPS: Profile saved.")
				
				-- Restore the global var
				Profiles_global_que = copyTable(Profiles_global_que_local)
				
				-- Make sure global var looks like before!
				wowUnit:assertEquals(Profiles_global_que[3],"Action bars","PAB slave")
				wowUnit:assertEquals(Profiles_global_que[2],"Macros","MPS slave")
				wowUnit:assertEquals(Profiles_global_que[1],"Keyboard binds","KPS slave")
			end,
			
			["4. KPS: Run standalone"] = function()
				
				-- Backup the global var
				local Profiles_global_que_local = {}
				Profiles_global_que_local = copyTable(Profiles_global_que)
				
				-- Kill MPS and PAB
				Profiles_global_que[2] = nil
				Profiles_global_que[3] = nil
				
				
				wowUnit:assertEquals(Profiles_global_que[3],nil,"PAB removed")
				wowUnit:assertEquals(Profiles_global_que[2],nil,"MPS removed")
				wowUnit:assertEquals(Profiles_global_que[1],"Keyboard binds","KPS")
				
				MPS:PreSaveMacroProfile("TestSuiteTestProfile")
				
				wowUnit:assert(KPS:ExistsProfile('TestSuiteTestProfile'),"MPS: Profile saved.")
				
				-- Restore the global var
				Profiles_global_que = copyTable(Profiles_global_que_local)
				
				-- Make sure global var looks like before!
				wowUnit:assertEquals(Profiles_global_que[3],"Action bars","PAB")
				wowUnit:assertEquals(Profiles_global_que[2],"Macros","MPS")
				wowUnit:assertEquals(Profiles_global_que[1],"Keyboard binds","KPS")
			end,
		},
		
		["2. ProfilesHub Blackbox"] = 
		{
			setup = function()
					PROFILES_TYST = 1
			end,
			
			teardown = function()
				PROFILES_TYST = nil
			end,
			
			["1. PAB Master"] = function()
				local testID = wowUnit:pauseTesting(10,"ABS_Master");
				local timeElapsed = 0;
				local timeFrame = CreateFrame("Frame");
				timeFrame:SetScript("OnUpdate", function(self, elapsed)
					timeElapsed = timeElapsed + elapsed;

					if (timeElapsed > 5) then
						timeFrame:SetScript("OnUpdate", nil);   -- don't forget to remove checks like this, otherwise you might be spamming asserts every frame
						-- Check results
						wowUnit:assert(PAB:ExistsProfile('Test1'),"Profile in PAB?")
						wowUnit:assert(MPS:ExistsProfile('Test1'),"Profile in MPS?")
						wowUnit:assert(KPS:ExistsProfile('Test1'),"Profile in KPS?")
						
						PAB:DeleteProfil("Test1")
						KPS:DeleteProfil("Test1")
						MPS:DeleteProfil("Test1")
						
						wowUnit:resumeTesting(testID);
					end
				end)

				PAB:PreSaveABProfile("Test1") -- Run code
			end,
			
			["2. KPS Master"] = function()
				local testID = wowUnit:pauseTesting(10,"KPS_Master");
				local timeElapsed = 0;
				local timeFrame = CreateFrame("Frame");
				timeFrame:SetScript("OnUpdate", function(self, elapsed)
					timeElapsed = timeElapsed + elapsed;

					if (timeElapsed > 5) then
						timeFrame:SetScript("OnUpdate", nil);   -- don't forget to remove checks like this, otherwise you might be spamming asserts every frame
						-- Check results
						wowUnit:assert(PAB:ExistsProfile('Test2'),"Profile in PAB?")
						wowUnit:assert(MPS:ExistsProfile('Test2'),"Profile in MPS?")
						wowUnit:assert(KPS:ExistsProfile('Test2'),"Profile in KPS?")
						
						PAB:DeleteProfil("Test2")
						KPS:DeleteProfil("Test2")
						MPS:DeleteProfil("Test2")

						wowUnit:resumeTesting(testID);
					end
				end)
				
				KPS:PreSaveBindsProfile("Test2") -- Run code
			end,
			
			["3. MPS Master"] = function()
				local testID = wowUnit:pauseTesting(10,"MPS_Master");
				local timeElapsed = 0;
				local timeFrame = CreateFrame("Frame");
				timeFrame:SetScript("OnUpdate", function(self, elapsed)
					timeElapsed = timeElapsed + elapsed;

					if (timeElapsed > 5) then
						timeFrame:SetScript("OnUpdate", nil);   -- don't forget to remove checks like this, otherwise you might be spamming asserts every frame
						-- Check results
						wowUnit:assert(PAB:ExistsProfile('Test3'),"Profile in PAB?")
						wowUnit:assert(MPS:ExistsProfile('Test3'),"Profile in MPS?")
						wowUnit:assert(KPS:ExistsProfile('Test3'),"Profile in KPS?")
						
						PAB:DeleteProfil("Test3")
						KPS:DeleteProfil("Test3")
						MPS:DeleteProfil("Test3")
						
						wowUnit:resumeTesting(testID);
					end
				end)
				
				MPS:PreSaveMacroProfile("Test3") -- Run code
			end,
			
			
			
		},
		
	}

	wowUnit:StartTests(PAB.profiles_hub_tests)
	end
end

PAB.tests = 
{
	["1. PAB basic tests"] =
	{
		setup = function()
			PROFILES_TYST = 1
		end,
		
		teardown = function()
			PROFILES_TYST = nil
		end,
		
		
		
		["1. Initialize"] = function()
			wowUnit:assertEquals(select(2,UnitClass('player')),"WARLOCK","Class WARLOCK, tests will pass")
			PAB:PreSaveABProfile("testSuiteSave_ORIGINAL") -- SAVE FOR RESTORE
			wowUnit:assertEquals(Profiles_global_que[3],"Action bars","PAB loaded as slave")
			wowUnit:assert(PAB,"Object instance loaded")
			wowUnit:assert(PABdb, "DB Loaded")
		end,
		["2. ExistsProfile()"] = function()
			wowUnit:assert(PAB:SaveABSProfile("testSuiteSave"),"Profile saved")
			wowUnit:assert(PAB:ExistsProfile('testSuiteSave'),"Profile seen by ExistsProfile()")
			wowUnit:assert(PAB:DeleteProfil("testSuiteSave"),"Profile deleted")
		
			wowUnit:isNil(PAB:ExistsProfile('123124'),"Non-existant profile should error.")
			wowUnit:isNil(PAB:ExistsProfile('123124',1),"Non-existant global profile should error.")
		end,
		["4. Save()"]= function()
			
			-- Terminate ProfilesHub Modules
			local Profiles_global_que_local = {}
			Profiles_global_que_local = copyTable(Profiles_global_que)
			Profiles_global_que[3] = "Action bars"
			
			ClearCursor()
			
			
			-------------------------------
			--			Do we save the actionbars in the correct order [AB Id]?
			--			Are the db records in order ?
			-------------------------------

			PAB:PutonActionbar(6603,1,"spell") -- spell
			PAB:PutonActionbar("BattlePet-0-00000265DB85",2,"summonpet") -- companion
			PAB:PutonActionbar(6948,3,"item") -- item
			PAB:PutonActionbar("test",4,"equipmentset") -- eqset
			PAB:PutonActionbar("Summon Demon",5,"flyout") -- flyout
			PAB:PutonActionbar("BattlePet-0-00000265DB84",7,"summonpet") -- summonpet
			
			PAB:SaveABSProfile("testSuiteSave")
			
			PAB:CheckDB(6603,1,"Auto Attack","spell","testSuiteSave")
			PAB:CheckDB("BattlePet-0-00000265DB85",2,"Mr. Chilly","summonpet","testSuiteSave")
			PAB:CheckDB(6948,3,"Hearthstone","item","testSuiteSave")
			PAB:CheckDB("test",4,"Equipment set","equipmentset","testSuiteSave")
			PAB:CheckDB("Summon Demon",5,"Summon Demon","flyout","testSuiteSave")
			PAB:CheckDB("BattlePet-0-00000265DB84",7,"Argent Gruntling","summonpet","testSuiteSave")

			PAB:DeleteProfil("testSuiteSave")
			-------------
			
			
			-- Reenable ProfilesHub Modules
			Profiles_global_que = copyTable(Profiles_global_que_local)
			
		end,
		["5. Load()"]= function()
			--- Do not load non existent profile [should fail]
			PAB:DeleteProfil("testSuiteLoad")
			wowUnit:isNil(PAB:LoadABSProfile("testSuiteLoad"),"Non-existant profile not loaded")
			
			-------------------------------
			--			Do we load profiles at all ?
			--			Do we load duplicate abs ?
			--			Do we avoid loading non-existant itams/companions or spells ?
			-------------------------------
			
			--- Profile 1 - Normal check
			-------------
			PAB:PutonActionbar(6603,1,"spell") -- spell
			PAB:PutonActionbar("BattlePet-0-00000265DB85",2,"summonpet") -- companion
			PAB:PutonActionbar(6948,3,"item") -- item
			PAB:PutonActionbar("test",4,"equipmentset") -- eqset
			PAB:PutonActionbar("Summon Demon",5,"flyout") -- flyout
			PAB:PutonActionbar("BattlePet-0-00000265DB84",7,"summonpet") -- summonpet

			PAB:SaveABSProfile("testSuiteLoad")
			
			--- Profile 2 - Control option for Normal check, diff macros
			-------------
			PAB:PutonActionbar(6603,4,"spell") -- spell
			PAB:PutonActionbar("BattlePet-0-00000265DB85",3,"summonpet") -- companion
			PAB:PutonActionbar(6948,2,"item") -- item
			PAB:PutonActionbar("test",1,"equipmentset") -- eqset
			PAB:PutonActionbar("BattlePet-0-00000265DB84",7,"summonpet") -- summonpet
			
			PAB:SaveABSProfile("testSuiteLoad2")
			
			
			--- Test 1 - Normal check
			-------------
			PAB:LoadABSProfile("testSuiteLoad")
			
			wowUnit:assertEquals(select(2,UnitClass('player')),"WARLOCK","Test 1 - Normal check\n")
			
			PAB:CheckGetActionInfo(6603,1,"Auto Attack","spell","testSuiteLoad")
			PAB:CheckGetActionInfo("BattlePet-0-00000265DB85",2,"Mr. Chilly", "summonpet","testSuiteLoad")
			PAB:CheckGetActionInfo(6948,3,"Hearthstone","item","testSuiteLoad")
			PAB:CheckGetActionInfo("test",4,"Equipment set","equipmentset","testSuiteLoad")
			PAB:CheckGetActionInfo("Summon Demon",5,"Flyout","flyout","testSuiteLoad")
			PAB:CheckGetActionInfo("BattlePet-0-00000265DB84",7,"Argent Gruntling","summonpet")
			
			PAB:LoadABSProfile("testSuiteLoad2")
			PAB:CheckGetActionInfo(6603,4,"Auto Attack","spell","testSuiteLoad")
			PAB:CheckGetActionInfo("BattlePet-0-00000265DB85",3,"Mr. Chilly", "summonpet","testSuiteLoad")
			PAB:CheckGetActionInfo(6948,2,"Hearthstone","item","testSuiteLoad")
			PAB:CheckGetActionInfo("test",1,"Equipment set","equipmentset","testSuiteLoad")
			PAB:CheckGetActionInfo("BattlePet-0-00000265DB84",7,"Argent Gruntling","summonpet")
			
			
			--- Profile 3 - Duplicate check
			-------------
			PAB:PutonActionbar(6603,1,"spell") -- spell
			PAB:PutonActionbar(6603,2,"spell") -- companion
			PAB:PutonActionbar(6948,3,"item") -- item
			PAB:PutonActionbar("test",4,"equipmentset") -- eqset
			PAB:PutonActionbar("BattlePet-0-00000265DB85",7,"summonpet") -- summonpet

			PAB:SaveABSProfile("testSuiteLoad3")
			
			--- Profile 4 - Avoid loading non-existant ab
			-------------
			PAB:PutonActionbar(45902,1,"spell") -- spell - Blood Strike
			PAB:PutonActionbar(70099,2,"companion") -- companion - Cenarion Hatchling
			PAB:PutonActionbar(70080,3,"item") -- item - Reforged Heartless
			PAB:PutonActionbar("test3",4,"equipmentset") -- eqset
			PAB:PutonActionbar("BattlePet-0-00000265DB84",7,"summonpet") -- summonpet

			PAB:SaveABSProfile("testSuiteLoad4")
			
			
			
			
			--- Test 2 - Duplicate check
			-------------
			PAB:LoadABSProfile("testSuiteLoad3")
			
			wowUnit:assertEquals(select(2,UnitClass('player')),"WARLOCK","Test 2 - Duplicate check\n")
			
			PAB:CheckGetActionInfo(6603,1,"Auto Attack","spell","testSuiteLoad3")
			PAB:CheckGetActionInfo(6603,2,"Auto Attack","spell","testSuiteLoad3")
			PAB:CheckGetActionInfo(6948,3,"HearthStone","item","testSuiteLoad3")
			PAB:CheckGetActionInfo("test",4,"Equipment set","equipmentset","testSuiteLoad3")
			
	
			
			--- Test 3 - Avoid loading non-existant ab
			-------------
			PAB:LoadABSProfile("testSuiteLoad4")
			
			wowUnit:assertEquals(select(2,UnitClass('player')),"WARLOCK","Test 3 - Avoid loading non-existant ab\n")
			
			PAB:CheckGetActionInfo(45902,1,"Unknown spell","spell","testSuiteLoad4","assertNonEquals")
			PAB:CheckGetActionInfo(70099,2,"Unknown companion","companion","testSuiteLoad4","assertNonEquals")
			PAB:CheckGetActionInfo(70080,3,"Unknown item","companion","testSuiteLoad4","assertNonEquals")
			PAB:CheckGetActionInfo("test3",4,"Unknown Equipment set","equipmentset","testSuiteLoad4","assertNonEquals")
			
			--- Test 3 - Summon mount check
			-------------
			PAB:PutonActionbar(C_MountJournal.Pickup(mountsCache["280"]),1,"summonmount") 		-- Mount at AB 1
			PAB:SaveABSProfile("testSuiteLoad3")
			
			PickupAction(1)																   		-- Delete the mount
			ClearCursor()
			
			PAB:LoadABSProfile("testSuiteLoad3")												-- Load again
			
			local test3_getactionInfo_TYPE, test3_getactioninfo_SPELLID, _ = GetActionInfo(1) 	-- Mount still there after load ?			
			wowUnit:assertEquals(GetActionInfo(1),test3_getactionInfo_TYPE,"Summoned mount name")
			wowUnit:assertEquals(GetActionInfo(1),test3_getactioninfo_SPELLID,"Summoned mount spell id")
			
			-- Test 4 - Patch 6.2 "Call to Arms"/"Garisson ability" does not exist in spellbook
			-------------
			
				-- Save profile with CtA
				ClearCursor()
				PickupSpell(161691)
				PlaceAction(1)
				PAB:SaveABSProfile("testSuiteLoad4")
				
				-- Replace with another spell
				PickupAction(1)																   		
				ClearCursor()
				PAB:PutonActionbar(6603,1,"spell") -- spell
				
				-- Load and see if CtA came back, ovrwriting 6603
				PAB:LoadABSProfile("testSuiteLoad4")
				local _, test4_SPELLID,  _ = GetActionInfo(1) 	-- Doesnt give name "Call to Arms"
				local test4_NAME = GetSpellInfo(test4_SPELLID) 	-- Translates into "CtA" (CtA has many spellids!)
				
				wowUnit:assertEquals(test4_NAME,"Call to Arms","Call to Arms")
				
			
			
			-- The end
			PAB:DeleteProfil("testSuiteLoad")
			PAB:DeleteProfil("testSuiteLoad2")
			PAB:DeleteProfil("testSuiteLoad3")
			PAB:DeleteProfil("testSuiteLoad4")
		end,
		["6. Failsafe profile"] = function()
			---
			--- Test: At first run saves
			--- Try to load it, try to overwrite it,try to delete it
			---
			
			-- Copy backup
			PABdb:SetProfile("Restore_backup")
			PABdb:CopyProfile("Restore [LOCKED]")
			
			-- Delete original
			PABSAVERESTORE = 1
			PAB:DeleteProfil("Restore [LOCKED]")
			PABSAVERESTORE = nil
			wowUnit:isNil(PAB:ExistsProfile('Restore [LOCKED]'),"Backup profile deleted")
			
			
			-- Create a new macro
			PAB:PutonActionbar(6603,1,"spell") -- spell
			
			-- Save once
			PAB:SaveABSProfile("Restore [LOCKED]")
			wowUnit:assert(PAB:ExistsProfile('Restore [LOCKED]'),"Backup profile created at first run")
			
			-- Save once more, trying to overwrite the already saved profile. [Should fail]
			wowUnit:isNil(PAB:SaveABSProfile("Restore [LOCKED]"),"SAVE: Overwrite protection")
			
			-- Try to delete LOCKED profile [Should fail]
			wowUnit:isNil(PAB:DeleteProfil("Restore [LOCKED]"),"DELETE: protection") 
			
			-- Try to load LOCKED profile [Should succeed]
			wowUnit:assert(PAB:LoadABSProfile("Restore [LOCKED]"),"LOAD: allways load")
			
			-- Restore eveything back to normal state
			PABdb:SetProfile("Restore [LOCKED]")
			PABdb:CopyProfile("Restore_backup")
		end,
		
		["7. Export()"] = function()
			
			---
			--- ProfilesHub Export integrity
			---
			PAB:PutonActionbar(6603,1,"spell") -- spell AutoAttack
			PAB:PreSaveABProfile("testSuiteSave")
			
			PAB:PreExport("testSuiteSave")
			wowUnit:assert(PAB:ExistsProfile('General: testSuiteSave'),"PHUB - PAB: Profile exported")
			if MPS then wowUnit:assert(MPS:ExistsProfile('General: testSuiteSave'),"PHUB - MPS: Profile exported") end
			if KPS then wowUnit:assert(KPS:ExistsProfile('General: testSuiteSave'),"PHUB - KPS: Profile exported") end
			
			PAB:PreDeleteProfile("General: testSuiteSave")
			wowUnit:isNil(PAB:ExistsProfile('General: testSuiteSave'),"PHUB - PAB: Profile deleted")
			if MPS then wowUnit:isNil(MPS:ExistsProfile('General: testSuiteSave'),"PHUB - MPS: Profile deleted") end
			if KPS then wowUnit:isNil(KPS:ExistsProfile('General: testSuiteSave'),"PHUB - KPS: Profile deleted") end
			
			---
			--- Export integrity
			---
			
			PAB:PutonActionbar(6603,1,"spell") -- spell AutoAttack
			PAB:SaveABSProfile("testSuiteSave")
			
			PAB:PutonActionbar(1490,1,"spell") -- spell,Corruption
			PAB:SaveABSProfile("testSuiteSave2")
			
			
			wowUnit:assert(PAB:ExportCharProfile("testSuiteSave"),"EXPORT testSuiteSave")
			wowUnit:assert(PAB:ExportCharProfile("testSuiteSave2"),"EXPORT testSuiteSave2")
			

			PABglobaldb:SetProfile("General: testSuiteSave")
			wowUnit:assertEquals(PABglobaldb.profile[1][2],6603,"EXPORT: Spell is here in 1st profile!")
			
			PABglobaldb:SetProfile("General: testSuiteSave2")
			wowUnit:assertEquals(PABglobaldb.profile[1][2],1490,"EXPORT: Spell is here in 2nd profile!")
			
			
			---
			--- Import integrity
			---
			PAB:LoadABSProfile("General: testSuiteSave")
			wowUnit:assertEquals(PABglobaldb.profile[1][2],6603,"IMPORT: Spell is here in 1st profile!")

			
			PAB:LoadABSProfile("General: testSuiteSave2")
			wowUnit:assertEquals(PABglobaldb.profile[1][2],1490,"IMPORT: Spell is here in 2nd profile!")
			
			
			---
			--- Delete integrity
			---
			wowUnit:assert(PAB:ExistsProfile('General: testSuiteSave'),"Profile seen by ExistsProfile()")
			wowUnit:assert(PAB:DeleteProfil("General: testSuiteSave"),"Profile deleted")
			wowUnit:isNil(PAB:ExistsProfile('General: testSuiteSave'),"Profile NOT seen by ExistsProfile()")
			
			wowUnit:assert(PAB:ExistsProfile('General: testSuiteSave2'),"Profile seen by ExistsProfile()")
			wowUnit:assert(PAB:DeleteProfil("General: testSuiteSave2"),"Profile deleted")
			wowUnit:isNil(PAB:ExistsProfile('General: testSuiteSave2'),"Profile NOT seen by ExistsProfile()")
			
		end,
		
		["8. Unoptimized load"]= function()
			
			
			-- Terminate ProfilesHub Modules
			local Profiles_global_que_local = {}
			Profiles_global_que_local = copyTable(Profiles_global_que)
			Profiles_global_que[3] = "Action bars"
			
			ClearCursor()
			
			
			-------------------------------
			--		Profile 1
			--		3 action buttons occupied 
			-------------------------------
			PAB:PutonActionbar(6603,1,"spell") -- spell
			PAB:PutonActionbar(55068,2,"spell") -- companion
			PAB:PutonActionbar(6948,3,"item") -- item
			
			PAB:SaveABSProfile("testSuiteSave")
			
			
			
			-------------------------------
			--		Profile 2
			--		2 action buttons occupied
			-------------------------------
			PAB:PutonActionbar(6603,1,"spell") -- spell
			PAB:PutonActionbar(55068,2,"spell") -- companion
			PickupAction(3)
			ClearCursor()
			
			PAB:SaveABSProfile("testSuiteSave2")
			
			
			
			-------------------------------
			--		THE TEST
			--		Unoptimized_load ON means we load empty spaces as well!
			--		P1
			-- 		(6603,1,"spell")
			-- 		(55068,2,"spell")
			-- 		(6948,3,"item")
			--
			--		P2
			--		(6603,1,"spell")
			-- 		(55068,2,"spell")
			-- 		(,3,"") -- <-- SHOULD BE NIL (Unoptimized_load ON)
			--
			--		Load P1, check 3 bars, Load P2, check that action button nr 3 is removed because
			--		it wasn't defined in Profile 2!
			-------------------------------
			
			local orig_PAB_Unoptimized_load = PABdb.char.PAB_Unoptimized_load
			
			wowUnit:assertEquals(select(2,UnitClass('player')),"WARLOCK","Unoptimized_load ON")
			
			PABdb.char.PAB_Unoptimized_load = 1
			wowUnit:assert(PABdb.char.PAB_Unoptimized_load, "Check option for enabling Unpotimized load")
			
			PAB:LoadABSProfile("testSuiteSave")
			PAB:CheckGetActionInfo(6603,1,"Auto Attack","spell","testSuiteSave")
			PAB:CheckGetActionInfo(55068,2,"Mr. Chilly", "companion","testSuiteSave")
			PAB:CheckGetActionInfo(6948,3,"Hearthstone","item","testSuiteSave")
			
			PAB:LoadABSProfile("testSuiteSave2")
			PAB:CheckGetActionInfo(6603,1,"Auto Attack","spell","testSuiteSave")
			PAB:CheckGetActionInfo(55068,2,"Mr. Chilly", "companion","testSuiteSave")
			PAB:CheckGetActionInfo(6948,3,"Hearthstone","item","testSuiteSave","assertNonEquals") -- Should be removed
			
			-------------------------------
			--		Unoptimized_load OFF means we load empty spaces as well!
			--		P1
			-- 		(6603,1,"spell")
			-- 		(55068,2,"spell")
			-- 		(6948,3,"item")
			--
			--		P2
			--		(6603,1,"spell")
			-- 		(55068,2,"spell")
			-- 		(,3,"") -- <-- SHOULD BE AS IN P1! (Unoptimized_load OFF)
			--
			--		Load P1, check 3 bars, Load P2, check that action button nr 3 is the same as Profile 1!
			--		Check IF THE OPTION FLAG IS NOT SET!
			--
			--		Default setting
			-------------------------------
			wowUnit:assertEquals(select(2,UnitClass('player')),"WARLOCK","Unoptimized_load OFF")
			
			PABdb.char.PAB_Unoptimized_load = 0
			wowUnit:assertEquals(PABdb.char.PAB_Unoptimized_load,0, "Check option for enabling Unpotimized load")
			
			PAB:LoadABSProfile("testSuiteSave")
			PAB:CheckGetActionInfo(6603,1,"Auto Attack","spell","testSuiteSave")
			PAB:CheckGetActionInfo(55068,2,"Mr. Chilly", "companion","testSuiteSave")
			PAB:CheckGetActionInfo(6948,3,"Hearthstone","item","testSuiteSave")
			
			PAB:LoadABSProfile("testSuiteSave2")
			PAB:CheckGetActionInfo(6603,1,"Auto Attack","spell","testSuiteSave")
			PAB:CheckGetActionInfo(55068,2,"Mr. Chilly", "companion","testSuiteSave")
			PAB:CheckGetActionInfo(6948,3,"Hearthstone","item","testSuiteSave") -- Should be here still

			PAB:DeleteProfil("testSuiteSave")
			PAB:DeleteProfil("testSuiteSave2")
			

			PAB:DeleteProfil("testSuiteSave")
			PAB:DeleteProfil("testSuiteSave2")
			PABdb.char.PAB_Unoptimized_load = orig_PAB_Unoptimized_load
			-------------
			
			
			-- Reenable ProfilesHub Modules
			Profiles_global_que = copyTable(Profiles_global_que_local)
			
		end,
		["99. The end"] = function()
			PAB:PreLoadABProfile("testSuiteSave_ORIGINAL") -- SAVE FOR RESTORE
			PAB:DeleteProfil("testSuiteSave")
			PAB:DeleteProfil("testSuiteLoad")
			PAB:DeleteProfil("testSuiteSave2")
			PAB:DeleteProfil("testSuiteSave_ORIGINAL")
		end,
	}
}

--- Check DB PABdb.profile against USER_INPUT
-- What did we save in ACEDB ?
function PAB:CheckDB(UI_SpellID,UI_actionBarPos,UI_SpellName,UI_SpellType,profileName)

	PABdb:SetProfile(profileName)
	
	-- Spell ID
	wowUnit:assertEquals(PABdb.profile[UI_actionBarPos][2],UI_SpellID,"Spell Name: "..UI_SpellName)
	-- Spell Type
	wowUnit:assertEquals(PABdb.profile[UI_actionBarPos][1],UI_SpellType,"Spell "..UI_SpellName.." is a "..UI_SpellType)
end

--- Check GetActionInfo() against USER_INPUT
-- What do we see on the actionbars ?
function PAB:CheckGetActionInfo(UI_SpellID,UI_actionBarPos,UI_SpellName,UI_SpellType,profileName,WOW_UNIT_METHOD)
	
	-- Get the loaded ab info
	local GetActionInfo_TYPE, GetActionInfo_SPELL_ID, _ = GetActionInfo(UI_actionBarPos)
	
	-- FLYOUT ID is a name, not a number
	if UI_SpellType == "flyout" then 
		local name = GetFlyoutInfo(GetActionInfo_SPELL_ID)
		GetActionInfo_SPELL_ID = name
	elseif (GetActionInfo_TYPE == "summonpet") then -- Convert hex to number
		GetActionInfo_SPELL_ID = GetActionInfo_SPELL_ID
	end
	
	if not GetActionInfo_SPELL_ID then GetActionInfo_SPELL_ID = "NULL VALUE!" end
	if not GetActionInfo_TYPE then GetActionInfo_TYPE = "NULL VALUE!" end
	
	-- Spell ID
	if WOW_UNIT_METHOD == "assertNonEquals" then
		wowUnit:assertNonEquals(GetActionInfo_SPELL_ID,UI_SpellID,"Spell Name: "..UI_SpellName)
	else
		wowUnit:assertEquals(GetActionInfo_SPELL_ID,UI_SpellID,"Spell Name: "..UI_SpellName)
	end
	
	
	-- Spell Type
	if WOW_UNIT_METHOD == "assertNonEquals" then
		wowUnit:assertNonEquals(GetActionInfo_TYPE,UI_SpellType,"Spell "..UI_SpellName.." is  NOT a "..UI_SpellType)
	else
		wowUnit:assertEquals(GetActionInfo_TYPE,UI_SpellType,"Spell "..UI_SpellName.." is  NOT a "..UI_SpellType)
	end
end

-- Put action on actionbar
function PAB:PutonActionbar(UI_SpellID,UI_actionBarPos,UI_SpellType)

	-- Clear current spot
	ClearCursor()
	PickupAction(UI_actionBarPos)
	ClearCursor()
	
	if     UI_SpellType == "spell" then
			PickupSpell(UI_SpellID)
	elseif UI_SpellType == "item" then
			PickupItem(UI_SpellID)
	elseif UI_SpellType == "equipmentset" then
			PickupEquipmentSetByName(UI_SpellID)
	elseif UI_SpellType == "companion"	 then
			PickupSpell(UI_SpellID)
	elseif UI_SpellType == "flyout"	then
			PickupSpellBookItem(PAB:GetSpellID_byName(UI_SpellID), BOOKTYPE_SPELL)
	elseif UI_SpellType == "summonpet"	then
			C_PetJournal.PickupPet(UI_SpellID)
	else
			return nil
	end
	
	
	
	PlaceAction(UI_actionBarPos)
	ClearCursor()
end